Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkCellLinks Class Reference

`#include <vtkCellLinks.h>`

Inheritance diagram for vtkCellLinks:

[legend]
Collaboration diagram for vtkCellLinks:

[legend]
List of all members.

## Detailed Description

object represents upward pointers from points to list of cells using each point

Date:
  2002/10/28 22:55:56

Revision:
  1.29

vtkCellLinks is a supplemental object to vtkCellArray and vtkCellTypes, enabling access from points to the cells using the points. vtkCellLinks is a list of Links, each link represents a dynamic list of cell id's using the point. The information provided by this object can be used to determine neighbors and construct other local topological information.

See also:
  vtkCellArray vtkCellTypes

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (51%)
  - Martin, Ken (15%)
  - Henderson, Amy (11%)
  - Miller, Jim (7%)
  - Barre, Sebastien (6%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkCellLinks.h)`
  - .`cxx` (`/Common/vtkCellLinks.cxx)`

Definition at line 52 of file vtkCellLinks.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | Allocate (vtkIdType numLinks, vtkIdType ext=1000)
Link & | GetLink (vtkIdType ptId)
unsigned short | GetNcells (vtkIdType ptId)
void | BuildLinks (vtkDataSet *data)
void | BuildLinks (vtkDataSet *data, vtkCellArray *Connectivity)
vtkIdType * | GetCells (vtkIdType ptId)
vtkIdType | InsertNextPoint (int numLinks)
void | InsertNextCellReference (vtkIdType ptId, vtkIdType cellId)
void | DeletePoint (vtkIdType ptId)
void | RemoveCellReference (vtkIdType cellId, vtkIdType ptId)
void | AddCellReference (vtkIdType cellId, vtkIdType ptId)
void | ResizeCellList (vtkIdType ptId, int size)
void | Squeeze ()
void | Reset ()
unsigned long | GetActualMemorySize ()
void | DeepCopy (vtkCellLinks *src)
## Static Public Methods
vtkCellLinks * | New ()
int | IsTypeOf (const char *type)
vtkCellLinks * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkCellLinks ()
| ~vtkCellLinks ()
void | IncrementLinkCount (vtkIdType ptId)
void | AllocateLinks (vtkIdType n)
Link * | Resize (vtkIdType sz)
void | InsertCellReference (vtkIdType ptId, unsigned short pos, vtkIdType cellId)
## Protected Attributes
Link * | Array
vtkIdType | Size
vtkIdType | MaxId
vtkIdType | Extend

## Member Typedef Documentation

typedef vtkObject vtkCellLinks::Superclass

| Reimplemented from vtkObject. Definition at line 65 of file vtkCellLinks.h.

## Constructor & Destructor Documentation

vtkCellLinks::vtkCellLinks | ( |  | ) | `[inline, protected]`

| Definition at line 131 of file vtkCellLinks.h.

vtkCellLinks::~vtkCellLinks | ( |  | ) | `[protected]`

## Member Function Documentation

vtkCellLinks* vtkCellLinks::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkCellLinks::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject.

int vtkCellLinks::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

virtual int vtkCellLinks::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

vtkCellLinks* vtkCellLinks::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject.

void vtkCellLinks::Allocate | ( | vtkIdType | numLinks,
|  | vtkIdType | ext = 1000
| ) |

| Allocate the specified number of links (i.e., number of points) that will be built.

Link& vtkCellLinks::GetLink | ( | vtkIdType | ptId | ) | `[inline]`

| Get a link structure given a point id. Definition at line 72 of file vtkCellLinks.h. References vtkIdType.

unsigned short vtkCellLinks::GetNcells | ( | vtkIdType | ptId | ) | `[inline]`

| Get the number of cells using the point specified by ptId. Definition at line 75 of file vtkCellLinks.h. References vtkIdType. Referenced by vtkPolyData::GetPointCells().

void vtkCellLinks::BuildLinks | ( | vtkDataSet * | data | ) |

| Build the link list array.

void vtkCellLinks::BuildLinks | ( | vtkDataSet * | data,
|  | vtkCellArray * | Connectivity
| ) |

| Build the link list array.

vtkIdType* vtkCellLinks::GetCells | ( | vtkIdType | ptId | ) | `[inline]`

| Return a list of cell ids using the point. Definition at line 84 of file vtkCellLinks.h. References vtkIdType. Referenced by vtkPolyData::GetPointCells().

vtkIdType vtkCellLinks::InsertNextPoint | ( | int | numLinks | ) |

| Insert a new point into the cell-links data structure. The size parameter is the initial size of the list.

void vtkCellLinks::InsertNextCellReference | ( | vtkIdType | ptId,
|  | vtkIdType | cellId
| ) | `[inline]`

| Insert a cell id into the list of cells (at the end) using the cell id provided. (Make sure to extend the link list (if necessary) using the method ResizeCellList().) Definition at line 170 of file vtkCellLinks.h. References Array, vtkCellLinks::Link::cells, vtkCellLinks::Link::ncells, and vtkIdType.

void vtkCellLinks::DeletePoint | ( | vtkIdType | ptId | ) | `[inline]`

| Delete point (and storage) by destroying links to using cells. Definition at line 163 of file vtkCellLinks.h. References Array, vtkCellLinks::Link::cells, vtkCellLinks::Link::ncells, and vtkIdType. Referenced by vtkPolyData::DeletePoint().

void vtkCellLinks::RemoveCellReference | ( | vtkIdType | cellId,
|  | vtkIdType | ptId
| ) | `[inline]`

| Delete the reference to the cell (cellId) from the point (ptId). This removes the reference to the cellId from the cell list, but does not resize the list (recover memory with ResizeCellList(), if necessary). Definition at line 176 of file vtkCellLinks.h. References Array, vtkCellLinks::Link::cells, vtkCellLinks::Link::ncells, and vtkIdType. Referenced by vtkPolyData::RemoveCellReference().

void vtkCellLinks::AddCellReference | ( | vtkIdType | cellId,
|  | vtkIdType | ptId
| ) | `[inline]`

| Add the reference to the cell (cellId) from the point (ptId). This adds a reference to the cellId from the cell list, but does not resize the list (extend memory with ResizeCellList(), if necessary). Definition at line 195 of file vtkCellLinks.h. References Array, vtkCellLinks::Link::cells, vtkCellLinks::Link::ncells, and vtkIdType. Referenced by vtkPolyData::AddCellReference().

void vtkCellLinks::ResizeCellList | ( | vtkIdType | ptId,
|  | int | size
| ) | `[inline]`

| Change the length of a point's link list (i.e., list of cells using a point) by the size specified. Definition at line 200 of file vtkCellLinks.h. References Array, vtkCellLinks::Link::cells, vtkCellLinks::Link::ncells, and vtkIdType. Referenced by vtkPolyData::ResizeCellList().

void vtkCellLinks::Squeeze | ( |  | ) |

| Reclaim any unused memory.

void vtkCellLinks::Reset | ( |  | ) |

| Reset to a state of no entries without freeing the memory.

unsigned long vtkCellLinks::GetActualMemorySize | ( |  | ) |

| Return the memory in kilobytes consumed by this cell links array. Used to support streaming and reading/writing data. The value returned is guaranteed to be greater than or equal to the memory required to actually represent the data represented by this object. The information returned is valid only after the pipeline has been updated.

void vtkCellLinks::DeepCopy | ( | vtkCellLinks * | src | ) |

| Standard DeepCopy method. Since this object contains no reference to other objects, there is no ShallowCopy.

void vtkCellLinks::IncrementLinkCount | ( | vtkIdType | ptId | ) | `[inline, protected]`

| Increment the count of the number of cells using the point. Definition at line 135 of file vtkCellLinks.h. References vtkIdType.

void vtkCellLinks::AllocateLinks | ( | vtkIdType | n | ) | `[protected]`

void vtkCellLinks::InsertCellReference | ( | vtkIdType | ptId,
|  | unsigned short | pos,
|  | vtkIdType | cellId
| ) | `[inline, protected]`

| Insert a cell id into the list of cells using the point. Definition at line 156 of file vtkCellLinks.h. References Array, vtkCellLinks::Link::cells, and vtkIdType.

Link* vtkCellLinks::Resize | ( | vtkIdType | sz | ) | `[protected]`

## Member Data Documentation

Link* vtkCellLinks::Array`[protected]`

| Definition at line 145 of file vtkCellLinks.h. Referenced by AddCellReference(), DeletePoint(), InsertCellReference(), InsertNextCellReference(), RemoveCellReference(), and ResizeCellList().

vtkIdType vtkCellLinks::Size`[protected]`

| Definition at line 146 of file vtkCellLinks.h.

vtkIdType vtkCellLinks::MaxId`[protected]`

| Definition at line 147 of file vtkCellLinks.h.

vtkIdType vtkCellLinks::Extend`[protected]`

| Definition at line 148 of file vtkCellLinks.h.

The documentation for this class was generated from the following file:

- Common/vtkCellLinks.h